-- Our char class
local char = {}
char.maxHealth = 8
char.health = 8
char.timeLastHurt = love.timer.getTime()
char.timeLastRegen = love.timer.getTime()
char.tileX = 13		-- The horizontal tile
char.tileY = 24		-- The vertical tile

-- Collision detection function.
-- Checks if an object overlaps with the character.
function char.CheckCollision(object)
  local char2x = Char.x + Char.width - 20
  local char2y = Char.y + Char.height - 20

  if object.hitBox then
    local object2x = object.x + object.hitBox.X2
    local object2y = object.y + object.hitBox.Y2
	
    return Char.x < object2x and char2x > object.x + object.hitBox.X1 and Char.y < object2y and char2y > object.y + object.hitBox.Y1 
  else
    local object2x = object.x + object.width
    local object2y = object.y + object.height
    return Char.x < object2x and char2x > object.x and Char.y < object2y and char2y > object.y  
  end
end

function char.getDist2(object)
  return math.pow(Char.x - object.x, 2) + math.pow(Char.y - object.y, 2)
end

return char
